{
     Animasi Bola Dunia
     ==================
     
     program animasi sederhana menggunakan opengl, dibuat meniru contoh yg ada
     di C++Builder
     kemungkinan masih ada error/bug...tapi sudah asyik koq!
     silahkan dikembangkan sendiri...
     have fun !!!!
      
     oleh:
           Adi Nugroho
           Jurusan Fisika
           FMIPA-UGM
     email:
           sendto_adinugroho@yahoo.com
     website:
           www.geocities.com/iniwebsiteku/
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  OpenGL;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
        latitude, longitude, latinc, longinc : GLfloat;
        radius : GLdouble;
        ghRC : HGLRC;
        ghDC : HDC;

    procedure DrawScene;
    procedure PolarView (var radius : GLdouble;
     twist: GLdouble; latitude: GLdouble; longitude: GLdouble);
    procedure initializeGL (width: GLsizei; height: GLsizei);
    procedure CreateObjects;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure SetupPixelFormat (DC: HDC);
const
        pfd : TPIXELFORMATDESCRIPTOR =
                (
                nSize: SizeOf (TPIXELFORMATDESCRIPTOR);
                nVersion: 1;
                dwFlags: PFD_SUPPORT_OPENGL or PFD_DRAW_TO_WINDOW or PFD_DOUBLEBUFFER;
                iPixelType: PFD_TYPE_RGBA;
                cColorBits: 8;
                { }
                cRedBits: 0;
                cRedShift: 0;

                cGreenBits: 0;
                cGreenShift: 0;

                cBlueBits: 0;
                cBlueShift: 0;

                cAlphaBits: 0;
                cAlphaShift: 0;
                
                cAccumBits: 0;           
                cAccumRedBits: 0;
                cAccumGreenBits: 0;
                cAccumBlueBits: 0;
                cAccumAlphaBits: 0;        

                cDepthBits: 16;
                cStencilBits: 0;
                cAuxBuffers: 0;
                iLayerType: PFD_MAIN_PLANE;
                bReserved: 0;

                dwlayerMask: 0;
                dwVisibleMask: 0;
                dwDamageMask: 0;
                );
var pixelFormat: integer;
begin
        pixelFormat := ChoosePixelFormat (DC, @pfd);
        if (pixelFormat=0) then
        begin
                MessageBox (WIndowFromDC(DC), 'ChoosePixelFormat failed.', 'Error',
                            MB_ICONERROR or MB_OK);
                exit;
        end;

        if (SetPixelFormat (DC, pixelFormat, @pfd) <> true) then
        begin
                MessageBox (WIndowFromDC(DC), 'SetPixelFormat failed.', 'Error',
                            MB_ICONERROR or MB_OK);
                exit;
        end;
end;

procedure TForm1.DrawScene;
begin
        glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
        glPushMatrix;

        latitude := latitude + latinc;
        longitude := longitude + longinc;

        polarView (radius, 0, latitude, longitude);

        glIndex (5);
        glCallList (3);

        glIndexi (8);
        glCallList (1);

        glIndexi (16);
        glPushMatrix;
        glTranslatef (0.8, -0.65, 0.0);
        glRotatef (30.0, 1.0, 0.5, 1.0);
        glCallList (2);
        glPopMatrix;
        glPopMatrix;

        SwapBuffers (ghDC);

end;

procedure TFOrm1.CreateObjects;
var     quadObj : GLUquadricObj;
begin   
        glnewList (1, GL_COMPILE);
        quadObj := gluNewQuadric;
        gluQuadricDrawStyle (quadObj, GLU_LINE);
        gluSphere (quadObj, 1.5, 16,16);
        glEndList;
        
        {     
        glnewList (3, GL_COMPILE);
        quadObj := gluNewQuadric;
        gluQuadricDrawStyle (quadObj, GLU_FILL);
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluCylinder (quadObj, 0.3, 0.0, 0.6, 15, 10);
        glEndList;

        glnewList (2, GL_COMPILE);
        glPushMatrix;
        glRotatef ( 90.0, 1.0, 0.0, 0.0);
        glTranslatef ( 0.0, 0.0, -1.0);
        quadObj := gluNewQuadric;
        gluQuadricDrawStyle (quadObj, GLU_FILL);
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluCylinder (quadObj, 0.3, 0.3, 0.6, 12, 2);
        glPopMatrix;
        glEndList;  }

end;

procedure TForm1.initializeGL (width: GLsizei; height: GLsizei);
var     maxObjectSize, aspect: GLfloat;
        near_plane : GLdouble;
begin
        glClearIndex (9.0);
        glClearDepth (1.0);
        glEnable (GL_DEPTH_TEST);
        glMatrixMode (GL_PROJECTION);
        aspect := width / height;
        gluPerspective (45.0, aspect, 3.0, 7.0);
        glMatrixMode (GL_MODELVIEW);

        near_plane := 3.0;
        maxObjectSize := 3.0;
        radius := near_plane + maxObjectSize / 2.0;

        latitude := 0.0;
        longitude := 0.0;
        latinc := 6.0;
        longinc := 2.5;

        createObjects;
end;

procedure TForm1.PolarView (var radius : GLdouble;
           twist: GLdouble; latitude: GLdouble; longitude: GLdouble);
begin
        glTranslated (0.0, 0.0, -radius);
        glRotated (-twist, 0.0, 0.0, 1.0);
        glRotated (-latitude, 1.0, 0.0, 0.0);
        glRotated (longitude, 0.0, 0.0, 1.0); 
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
        Timer1.Enabled := false;
        DrawScene;
     //   Yield;
        Timer1.Enabled := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        ghDC := GetDC (Handle);
        SetupPixelFormat (ghDC);
        ghRC := wglCreateContext (ghDC);
        wglMakeCurrent (ghDC, ghRC);

        initializeGL (ClientRect.Right, ClientRect.Bottom);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        Timer1.Enabled := false;
end;

procedure TForm1.FormResize(Sender: TObject);
var  aspect : GLfloat;
begin
     glViewport (0,0, ClientRect.Right, ClientRect.Bottom);
     aspect :=  ClientRect.Right / ClientRect.Bottom;
     glMatrixMode ( GL_PROJECTION);
     glLoadIdentity;
     gluPerspective ( 45.0, aspect, 3.0, 7.0);
     glMatrixMode ( GL_MODELVIEW);
end;

end.
